#ifndef DATADEF_H
#define DATADEF_H
  
// Boolean
#ifndef tag_BOOL
  #define tag_BOOL
  typedef unsigned char       BOOL;
#endif

#ifndef tag_BYTE
  #define tag_BYTE
  typedef unsigned char BYTE;
#endif

#ifndef tag_WORD
  #define tag_WORD
  typedef unsigned short WORD;
#endif

#ifndef tag_DWORD
  #define tag_DWORD
  #ifndef DWORD
     typedef unsigned long DWORD;    
  #endif
#endif

#ifndef tag_UDWORD
  #define tag_UDWORD
  #ifndef UDWORD
     typedef union{
         unsigned long dw;
         BYTE  b[4];
     }UDWORD;    
  #endif
#endif


// Unsigned numbers
#ifndef tag_UINT8
  #define tag_UINT8
  typedef unsigned char UINT8;
#endif

typedef unsigned int        UINT16;
typedef unsigned long       UINT32;

// Signed numbers
typedef signed char         INT8;
typedef signed int          INT16;
typedef signed long         INT32;
//-------------------------------------------------------------------------------------------------------
// UDBYTE- unsigned double byte used for byte access of 16-bit words
// This union is different for big and little endian compilers.
//

#ifndef tag_UDBYTE
#define tag_UDBYTE

#define BIGENDIAN

#ifdef BIGENDIAN
   typedef union {
      WORD w;
      struct {
         BYTE hi;
         BYTE lo;
      }b;
   } UDBYTE;
#else
   typedef union {
      WORD w;
      struct {
         BYTE lo;
         BYTE hi;
      }b;
   } UDBYTE;
#endif
#endif

//--------------------------------------------------------------------------------------------------
//    THIS IS BROKEN. USED FOR DEBUG ONLY!!!!
#ifndef tag_QWORD
	#define tag_QWORD
		#define SIZEOFQWORD 8

		typedef BYTE QWORD[SIZEOFQWORD];

		typedef union {
		   BYTE Extended[8];
 		   WORD Short[4];
		}ADDRESS;
#endif



//-------------------------------------------------------------------------------------------------------
// Common values
#ifndef FALSE
    #define FALSE 0
#endif
#ifndef TRUE
    #define TRUE 1
#endif
#ifndef NULL
    #define NULL 0
#endif
//-------------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------------
// Useful stuff
#define BM(n) (1 << (n))
#define BF(x,b,s) (((x) & (b)) >> (s))
#define MIN(n,m) (((n) < (m)) ? (n) : (m))
#define MAX(n,m) (((n) < (m)) ? (m) : (n))
#define ABS(n) ((n < 0) ? -(n) : (n))

// Dynamic function pointer
typedef void (*VFPTR)(void);
//-------------------------------------------------------------------------------------------------------

#endif

