
#ifndef HAL_INIT_F121_H
#define HAL_INIT_F121_H

// General
#define ENABLE_GLOBAL_INT()         do { EA = 1;_nop_();_nop_();} while (0)
#define DISABLE_GLOBAL_INT()        do { EA = 0; } while (0) 
//#define DISABLE_GLOBAL_INT()        do { EA = 1; } while (0) 

#define GLOBAL_INT_OPEN_FLAG()      (EA)

//-------------------------------------------------------------------------------------------------------
// PCA0 interrupts

#define ENABLE_PCA0_INT()      do { EIE1 |= 0x08;} while (0)
#define DISABLE_PCA0_INT()     do { EIE1 |= 0x08; } while (0)
#define ENABLE_PCA0_MOD0()  do { SFRPAGE = PCA0_PAGE; PCA0CPM0 = 0x21;} while (0)
#define DISABLE_PCA0_MOD0() do { SFRPAGE = PCA0_PAGE; PCA0CPM0 = 0x00;} while (0)
#define ENABLE_PCA0_MOD1()  do { SFRPAGE = PCA0_PAGE; PCA0CPM1 = 0x4D;} while (0)
#define DISABLE_PCA0_MOD1() do { SFRPAGE = PCA0_PAGE; PCA0CPM1 = 0x00;} while (0)
#define ENABLE_PCA0_MOD2()  do { SFRPAGE = PCA0_PAGE; PCA0CPM2 = 0x49;} while (0)
#define DISABLE_PCA0_MOD2() do { SFRPAGE = PCA0_PAGE; PCA0CPM2 = 0x00;} while (0)



/*******************************************************************************************************
 *******************************************************************************************************
 **************************                      PCA0                         **************************
 *******************************************************************************************************
 *******************************************************************************************************/


//-------------------------------------------------------------------------------------------------------

// Start/stop
#define PCA0_START() \
do { \
SFRPAGE = PCA0_PAGE; \
PCA0CN |= 0x40; \
} while (0)

#define PCA0_STOP() \
do { \
SFRPAGE = PCA0_PAGE; \
PCA0CN &= ~0x40; \
} while (0)

//-------------------------------------------------------------------------------------------------------
//  void halWait(UINT16 timeout)
//
//  DESCRIPTION:
//      Runs an idle loop for [timeout] microseconds.
//
//  ARGUMENTS:
//      UINT16 timeout
//          The timeout in microseconds
//-------------------------------------------------------------------------------------------------------
#if 1 //original
void halWait_us(unsigned short timeout);
#else //peilin modified
void halWait_us(unsigned long timeout);
#endif


void SYSCLK_Init(void);
void CPU_Init(void);
void Port_Init(void);
void MAC_Port_Init(void );
void PCA0_Init(void);
void FIFOP_Int_Init(void);

#endif

/*******************************************************************************************************
 * Revision history:
 *
 * $Log: hal_init_F121.h,v $
 * Revision 1.1  2005/03/30 18:19:38  cvs
 * init
 * by rongbin.xue
 * 30/3/2005
 *
 * Revision 1.2  2005/01/23 18:59:14  henk
 * First non-beacon release
 *
 *******************************************************************************************************/

