/******************************************************************************
 *
 * $RCSfile: types.h,v $
 * $Revision: 1.1 $
 *
 * This module defines some regularly used variable types.
 *
 *****************************************************************************/

#ifndef INC_TYPES_H
#define INC_TYPES_H

#ifdef LINUX_HOST
  #include <sys/types.h>
#endif

/* typedefs are here. The types are only defined if they haven't been previously
   defined. The file stdint.h defines these same types and is included when not
   using the -mno-cygwin flag during compilation. */
#if !defined(_STDINT_H) && !defined (_STDINT_H_)
  typedef unsigned char       uint8_t;
  typedef unsigned short     uint16_t;
  typedef unsigned long      uint32_t;
//  typedef unsigned long long uint64_t;
  #if !defined(LINUX_HOST)  && !defined(_SYS_TYPES_H_)  && !defined(_MACHTYPES_H_)
    typedef   signed char        int8_t;
    typedef   signed short      int16_t;
    typedef   signed long       int32_t;
//    typedef   signed long long  int64_t;
  #endif
#endif

#endif // INC_TYPES_H
